<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "organization".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Organization".
 *
 * Columns in table "organization" available as properties of the model,
 * followed by relations of table "organization" available as properties of the model.
 *
 * @property integer $id
 * @property integer $organization_group_id
 * @property string $organization_name
 * @property string $status
 * @property string $onboarding
 * @property string $onboarding_date
 * @property string $onboarding_task_id
 * @property string $salesforce_id
 * @property string $reputation_insights
 * @property string $listings
 * @property string $package
 * @property string $type
 * @property string $yext_customer_id
 * @property integer $partner_site_id
 * @property string $date_added
 * @property string $adwords_cid
 * @property string $date_updated
 * @property string $date_pause_requested
 * @property string $pg_client_id
 * @property string $survey_syndication_enabled_date
 * @property string $bf_brand_id
 * @property string $dm_id
 * @property string $provconn_url
 * @property string $provconn_last_update
 *
 * @property OrganizationGroup $organizationGroup
 * @property PartnerSite $partnerSite
 * @property OrganizationAccount[] $organizationAccounts
 * @property OrganizationFeature[] $organizationFeatures
 * @property OrganizationHistory[] $organizationHistories
 */
class BaseOrganization extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'organization';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Organization|Organizations', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('organization_group_id, partner_site_id, bf_brand_id', 'numerical', 'integerOnly' => true),
            array('organization_name', 'length', 'max' => 100),
            array('status, onboarding', 'length', 'max' => 1),
            array('onboarding_task_id', 'length', 'max' => 6),
            array('salesforce_id', 'length', 'max' => 18),
            array('reputation_insights', 'length', 'max' => 56),
            array('listings', 'length', 'max' => 50),
            array('package', 'length', 'max' => 30),
            array('type', 'length', 'max' => 22),
            array('yext_customer_id', 'length', 'max' => 15),
            array('pg_client_id, provconn_url', 'length', 'max'=> 255),
            array('dm_id', 'length', 'max'=> 64),
            array('onboarding_date, date_added, date_updated, date_pause_requested, provconn_last_update, bf_brand_id', 'safe'),
            array('organization_group_id, organization_name, status, onboarding, onboarding_date, onboarding_task_id, salesforce_id, reputation_insights, listings, type, yext_customer_id, partner_site_id, date_added, date_updated, date_pause_requested, pg_client_id, provconn_url, provconn_last_update, bf_brand_id, dm_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, organization_group_id, organization_name, status, onboarding, onboarding_date, onboarding_task_id, salesforce_id, reputation_insights, listings, package, type, yext_customer_id, partner_site_id, date_added, date_updated, date_pause_requested, pg_client_id, provconn_url, provconn_last_update, bf_brand_id, dm_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'organizationGroup' => array(self::BELONGS_TO, 'OrganizationGroup', 'organization_group_id'),
            'partnerSite' => array(self::BELONGS_TO, 'PartnerSite', 'partner_site_id'),
            'organizationAccounts' => array(self::HAS_MANY, 'OrganizationAccount', 'organization_id'),
            'organizationFeatures' => array(self::HAS_MANY, 'OrganizationFeature', 'organization_id'),
            'organizationHistories' => array(self::HAS_MANY, 'OrganizationHistory', 'organization_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'organization_group_id' => null,
            'organization_name' => Yii::t('app', 'Organization Name'),
            'status' => Yii::t('app', 'Status'),
            'onboarding' => Yii::t('app', 'Onboarding'),
            'onboarding_date' => Yii::t('app', 'Onboarding Date'),
            'onboarding_task_id' => Yii::t('app', 'Onboarding Task'),
            'salesforce_id' => Yii::t('app', 'Salesforce'),
            'reputation_insights' => Yii::t('app', 'Reputation Insights'),
            'listings' => Yii::t('app', 'Listings'),
            'package' => Yii::t('app', 'Package'),
            'type' => Yii::t('app', 'Type'),
            'yext_customer_id' => Yii::t('app', 'Yext Customer'),
            'partner_site_id' => null,
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'date_pause_requested' => Yii::t('app', 'Date Pause Requested'),
            'pg_client_id' => Yii::t('app', 'Pg Client'),
            'bf_brand_id' => Yii::t('app', 'BF Brand Id'),
            'dm_id' => Yii::t('app', 'Data Manager Id'),
            'provconn_url' => Yii::t('app', 'Provconn Url'),
            'provconn_last_update' => Yii::t('app', 'Provconn Last Update'),
            'organizationGroup' => null,
            'organizationAccounts' => null,
            'organizationFeatures' => null,
            'organizationHistories' => null,
        );
    }

    public function search()
    {

        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('organization_group_id', $this->organization_group_id);
        $criteria->compare('organization_name', $this->organization_name, true);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('onboarding', $this->onboarding, true);
        $criteria->compare('onboarding_date', $this->onboarding_date, true);
        $criteria->compare('onboarding_task_id', $this->onboarding_task_id, true);
        $criteria->compare('salesforce_id', $this->salesforce_id, true);
        $criteria->compare('reputation_insights', $this->reputation_insights, true);
        $criteria->compare('listings', $this->listings, true);
        $criteria->compare('package', $this->package, true);
        $criteria->compare('type', $this->type, true);
        $criteria->compare('yext_customer_id', $this->yext_customer_id, true);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('date_pause_requested', $this->date_pause_requested, true);
        $criteria->compare('pg_client_id', $this->pg_client_id, true);
        $criteria->compare('bf_brand_id', $this->bf_brand_id, true);
        $criteria->compare('dm_id', $this->dm_id, true);
        $criteria->compare('provconn_url', $this->provconn_url, true);
        $criteria->compare('provconn_last_update', $this->provconn_last_update, true);

        return new CActiveDataProvider(get_class($this), array('criteria' => $criteria, 'pagination' => array('pageSize' => 100)));
    }

}
